<?php

namespace Drupal\uvf_migrate;

use Drupal\Core\Session\AccountInterface;
use Drupal\node\Entity\Node;
use Drupal\media\Entity\Media;
use Drupal\file\Entity\File;

/**
 * Service description.
 */
class Importcsv
{
    protected $currentUser;

    /**
     * CustomService constructor.
     * @param AccountInterface $currentUser
     */
    public function __construct(AccountInterface $currentUser)
    {
        $this->currentUser = $currentUser;
    }

    /**
     * @return \Drupal\Component\Render\MarkupInterface|string
     */
    public function getData()
    {
        return $this->currentUser->getDisplayName();
    }

    /**
     * Import Data.
     */
    public function importData()
    {
        /**
         * Import data from a CSV file.
         *
         * @param $script
         *  Path to the CSV file.
         */
        $dataFile = fopen('public://import-sources/broadcast_list.csv', 'r');
        // Read the document header,
        // this row shouldn't be processed.

        while (($line = fgetcsv($dataFile)) !== false) {
            //$line is an array of the csv elements

            if ($line[0] != 'nid') {
                $nid = $line[0];
                $node_storage = \Drupal::entityTypeManager()->getStorage(
                    'node'
                );
                $node = $node_storage->load($nid);

                //echo $node->title->value; // "Lorem Ipsum..."
                $author_simple = $line[17];

                preg_match_all(
                    '#\bhttps?://[^,\s()<>]+(?:\([\w\d]+\)|([^,[:punct:]\s]|/))#',
                    $author_simple,
                    $match
                );

                // Author Simple
                $social_media_url = $match[0];
                $strings = explode('https://', $author_simple);
                $name_surname = $strings[0];

                echo '<pre>';
                echo $name_surname;
                echo '</pre>';

                echo '<pre>';
                echo $social_media_url[0];
                echo '</pre>';

                $file_id = $line[16];
                $file = \Drupal\file\Entity\File::load($file_id);
                $uri = $file->getFileUri();
                $url = file_create_url($uri);

                echo '<pre>';
                echo $url;
                echo '</pre>';

                $media = Media::load($line[16]);

                echo '<pre>';
                print_r($media);
                echo '</pre>';

                echo '------------------'; // new line

                echo '<pre>';
                print_r($line);
                echo '</pre>';
            }
        }
        exit();

        fclose($dataFile);
    }
}
